"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _BaseComment_author, _BaseComment_content;
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseComment = void 0;
const Base_1 = require("./Base");
const SimpleUser_1 = require("./SimpleUser");
// TODO: Add missing docs to BaseComment
/**
 * Represents a BaseComment on iFunny
 * @extends Base<APIComment>
 */
class BaseComment extends Base_1.Base {
    /**
     * @param content Content the Comment is attached to
     * @param payload Payload of the Comment
     */
    constructor(content, payload) {
        super(content.client, payload);
        _BaseComment_author.set(this, null);
        _BaseComment_content.set(this, void 0);
        __classPrivateFieldSet(this, _BaseComment_content, content, "f");
    }
    /**
     * Content ID the comment is attached to
     */
    get content_id() {
        return this.get("cid");
    }
    /**
     * Content attached to the Comment
     */
    get content() {
        return __classPrivateFieldGet(this, _BaseComment_content, "f");
    }
    get thumbnails() {
        return this.get("content_thumbs");
    }
    get date() {
        return this.get("date");
    }
    get is_edited() {
        return this.get("is_edited");
    }
    is_reply() {
        return this.get("is_reply");
    }
    get is_smiled() {
        return this.get("is_smiled");
    }
    get is_unsmiled() {
        return this.get("is_unsmiled");
    }
    get last_reply() {
        return this.get("last_reply");
    }
    get num() {
        return this.get("num");
    }
    get state() {
        return this.get("state");
    }
    get status() {
        return this.get("status");
    }
    /**
     * The text of the Comment. Can be an empty string
     */
    get text() {
        return this.get("text");
    }
    /**
     * Author of the Comment
     * @alias creator
     */
    get author() {
        return (__classPrivateFieldSet(this, _BaseComment_author, __classPrivateFieldGet(this, _BaseComment_author, "f") ?? new SimpleUser_1.SimpleUser(this.client, this.get("user")), "f"));
    }
    /**
     * Author of the Comment
     * @alias author
     */
    get creator() {
        return this.author;
    }
}
exports.BaseComment = BaseComment;
_BaseComment_author = new WeakMap(), _BaseComment_content = new WeakMap();
exports.default = BaseComment;
//# sourceMappingURL=BaseComment.js.map