"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _News_payload;
Object.defineProperty(exports, "__esModule", { value: true });
exports.News = void 0;
// TODO: Document News properties
/**
 * Represents a News object from the Activity Feed
 */
class News {
    /**
     * @param news Payload of the News Object
     */
    constructor(news) {
        _News_payload.set(this, void 0);
        __classPrivateFieldSet(this, _News_payload, news, "f");
    }
    get payload() {
        return __classPrivateFieldGet(this, _News_payload, "f");
    }
    get(key) {
        return (this.payload[key] ?? null);
    }
    get date() {
        return new Date(this.get("date") * 1000);
    }
    get type() {
        return this.get("type");
    }
    get ban_id() {
        return this.get("banId");
    }
    get ban_message() {
        return this.get("banTypeMessage");
    }
    get ban_type() {
        return this.get("banType");
    }
    get comment() {
        return this.get("comment");
    }
    get content() {
        return this.get("content");
    }
    get count_active_strike() {
        return this.get("countActiveStrike");
    }
    get date_until() {
        return this.get("date_until");
    }
    get expired_at() {
        return this.get("expiredAt");
    }
    get image_url() {
        return this.get("imageUrl");
    }
    get mention_content() {
        return this.get("mention_content");
    }
    get mention_users() {
        return this.get("mention_users");
    }
    get purchase_type() {
        return this.get("purchaseType");
    }
    get reply() {
        return this.get("reply");
    }
    get smiles() {
        return this.get("smiles");
    }
    get strike_id() {
        return this.get("strikeId");
    }
    get text() {
        return this.get("text");
    }
    get title() {
        return this.get("title");
    }
    get url() {
        return this.get("url");
    }
    get user() {
        return this.get("user");
    }
    get username() {
        return this.get("username");
    }
}
exports.News = News;
_News_payload = new WeakMap();
exports.default = News;
//# sourceMappingURL=News.js.map