import { APIComment } from "@ifunny/ifunny-api-types";
import { Base } from "./Base";
import { SimpleUser } from "./SimpleUser";
import { Content } from "./Content";
/**
 * Represents a BaseComment on iFunny
 * @extends Base<APIComment>
 */
export declare class BaseComment extends Base<APIComment> {
    #private;
    /**
     * @param content Content the Comment is attached to
     * @param payload Payload of the Comment
     */
    constructor(content: Content, payload: APIComment);
    /**
     * Content ID the comment is attached to
     */
    get content_id(): string;
    /**
     * Content attached to the Comment
     */
    get content(): Content;
    get thumbnails(): import("@ifunny/ifunny-api-types").APIContentThumbnail;
    get date(): string;
    get is_edited(): boolean;
    is_reply(): boolean;
    get is_smiled(): boolean;
    get is_unsmiled(): boolean;
    get last_reply(): import("@ifunny/ifunny-api-types").APIReply | null;
    get num(): import("@ifunny/ifunny-api-types").APICommentNum;
    get state(): "normal" | "top" | "deleted" | "abused" | "deleted_self" | null;
    get status(): string;
    /**
     * The text of the Comment. Can be an empty string
     */
    get text(): string;
    /**
     * Author of the Comment
     * @alias creator
     */
    get author(): SimpleUser;
    /**
     * Author of the Comment
     * @alias author
     */
    get creator(): SimpleUser;
}
export default BaseComment;
//# sourceMappingURL=BaseComment.d.ts.map