import { Client } from "../client/Client";
/**
 * All feed times
 */
export declare enum FeedType {
    FEATURES = "feeds/featured",
    COLLECTIVE = "feeds/collective",
    HOME = "timelines/home",
    TIMELINE = "timelines/users"
}
/**
 * Config for pagination
 */
export interface PaginateConfig {
    limit?: number;
    is_new?: boolean;
    next?: string;
    prev?: string;
}
/**
 * Base Feed class
 */
export declare class BaseFeed {
    #private;
    /**
     * Types of feed
     */
    static readonly Types: typeof FeedType;
    /**
     * @param client Client attached to the BaseFeed
     * @param url The url for the feed
     */
    constructor(client: Client, url: string);
    /**
     * Client attached to the Feed
     */
    get client(): Client;
    /**
     * Url used for pagination
     */
    get url(): string;
}
export default BaseFeed;
//# sourceMappingURL=BaseFeed.d.ts.map