import { APINews } from "@ifunny/ifunny-api-types";
import { Nullify } from "../utils/Types";
/**
 * Represents a News object from the Activity Feed
 */
export declare class News {
    #private;
    /**
     * @param news Payload of the News Object
     */
    constructor(news: APINews);
    get payload(): APINews;
    protected get<K extends keyof APINews>(key: K): Nullify<APINews[K]>;
    get date(): Date;
    get type(): "ban" | "ban_action" | "comment" | "comment_for_repub" | "content_boost" | "user_deleted" | "featured" | "friend_registered" | "geo_friend_accepted" | "geo_friend_rejected" | "geo_friend_request" | "mention_content" | "mention_user" | "purchase_onetime" | "purchase_subscription" | "rejected_by_customs" | "reply_for_comment" | "reported_comment_banned" | "reported_content_banned" | "reported_user_banned" | "repub" | "repub_of_repub" | "smile" | "smile_for_comment" | "smile_for_reply" | "smile_for_repub" | "smile_tracker" | "special" | "strike_action" | "expire_strike" | "subscribe" | "unban" | "unban_action" | "user_undeleted";
    get ban_id(): string | null;
    get ban_message(): string | null;
    get ban_type(): "other" | "chat_access" | "comment_creation" | "content_creation" | "profile_access" | "repubing" | "smiling" | "subscribing" | "collective_shadow" | null;
    get comment(): import("@ifunny/ifunny-api-types").APIComment | null;
    get content(): import("@ifunny/ifunny-api-types").APIContent | null;
    get count_active_strike(): number | null;
    get date_until(): number | null;
    get expired_at(): number | null;
    get image_url(): string | null;
    get mention_content(): import("@ifunny/ifunny-api-types").APIContent | null;
    get mention_users(): import("@ifunny/ifunny-api-types").APIMentionUser[] | null;
    get purchase_type(): string | null;
    get reply(): import("@ifunny/ifunny-api-types").APIReply | null;
    get smiles(): number | null;
    get strike_id(): string | null;
    get text(): string | null;
    get title(): string | null;
    get url(): string | null;
    get user(): import("@ifunny/ifunny-api-types").APINewsUser | null;
    get username(): string | null;
}
export default News;
//# sourceMappingURL=News.d.ts.map